' VB Script zum Auslesen der Scheitelpunkte der selektierten Objekte
' Written May 29, 2009 by Kevan Chapman for IMSI/Design  als vertices.vbs
' Version 1.0.0 - first release into the wild.
' Ergnzt und bearbeitet von mike k. 14.03.2013
' Error-checking ist minimal -- es kann Objekte geben bei denen es nicht funktioniert
' Das script bearbeitet im Moment keine zusammengesetzten Objekte

' Gebrauchsanweisung: 
' Diesen Script funktioniert so nicht in der Macro Recorder Palette.
' Es luft per Doppelclick im Windows Script Host
'
option explicit
Dim TCApp ' the TurboCAD application -- must be running for this script to work'
Dim TCDraw ' the active drawing -- there must be an open drawing for this script to work
Dim TCSel ' the current selection. If nothing is selected the script will exit
Dim TCGrf ' used to cycle through each selected graphic'
Dim TCVertices ' gets the list of vertices for each graphic
Dim TCVert ' used to cycle through each vertex
Dim VertFile ' file used to store the results
Dim FilePath ' path to the output file. Normally the same folder as the open drawing.
Dim FSO ' FileSystemObject for access to file operations
Dim i ' counter for each selected graphic
Dim j ' counter for each vertex in each graphic
Dim Teil
Sub Main
  On Error Resume Next
  ' hook up to the running instance of TurboCAD
  Set TCApp = GetObject("", "TurboCAD.Application")
  If Err.Number <> 0 Then
    MsgBox "Unable to access TurboCAD. Error " & Hex(Err.Number) & ": " & Err.Description
    Err.Clear
    Exit Sub
  End If
  
  ' get the active drawing
  Set TCDraw = TCApp.ActiveDrawing
  If Err.Number <> 0 Then
    MsgBox "No drawing open. Nothing to do."
    Err.Clear
    Exit Sub
  End If
  
  ' get the current selection. If empty, complain and exit.
  Set TCSel = TCDraw.Selection
  If TCSel.Count < 1 Then
    MsgBox "Nothing selected. Nothing to do."
    Exit Sub
  End If
  
  ' start up the FileSystemObject for access to file operations.
  Set FSO = CreateObject("Scripting.FileSystemObject")
  
  ' determine the path for the output file
  FilePath = TCDraw.Path(0)
  If Len(FilePath) = 0 Then 'file hasn't been saved, so it has no path yet. Use the program folder in this case. 
    FilePath = TCApp.Path(0)
  Else
    Dim endpath ' strip the drawing filename off of the drawing's path, and append the output filename"'
    endpath = InStrRev(FilePath, "\")
    FilePath = Left(FilePath, endpath)
  End If
  
  ' open the output file for text operations
  Set VertFile = FSO.CreateTextFile(FilePath & "ScheitelPunkte.csv")
  VertFile.WriteLine "Scheitelpunkte der ausgewhlten Objekte" 
  VertFile.writeLine 
  
VertFile.WriteLine "Nr." & ";" & "ObjektID" & ";" & "ObjektInfo" & ";" & "PunktNr." & ";" & "X" & ";" & "Y" & ";" & "Z" 

  'process each of the selected objects, and print its vertices to the file
  For i = 0 to TCSel.Count - 1
    Set TCGrf = TCSel.Item(i)  
    Teil = TCGrf.Name
    Set TCVertices = TCGrf.Vertices
    TCVertices.UseWorldCS = True ' this allows us to get the World UCS coordinates rather than the graphic's local coordinates
    For j = 0 to TCVertices.Count - 1
      Set TCVert = TCVertices.Item(j)
      VertFile.WriteLine (i+1) &";"& TCGrf.ID &  ";"  & TCGrf.Name   & ";" & j & ";" & TCVert.X & ";" & TCVert.Y & ";" & TCVert.Z 
    Next 
    VertFile.WriteBlankLines(1)
  Next 
  'Close the output file'
  VertFile.Close
  MsgBox "Datei gespeichert als : " & FilePath & "Scheitelpunkte.csv"

  'cleanup objects
  TCVert = Nothing
  TCVertices = Nothing
  TCGrf = Nothing
  TCSel = Nothing
  TCDraw = Nothing
  TCApp = Nothing
End Sub  

Main
